package com.zd.exam.mapper;

import com.zd.exam.domain.ElExam;
import com.zd.exam.domain.vo.ElExamVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 课程(ElExam)表数据库访问层
 *
 * @author liubo
 * @since 2021-08-31 09:09:15
 */
public interface ElExamMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ElExam queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<ElExam> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param examvo 实例对象
     * @return 对象列表
     */
    List<ElExam> queryAll(ElExamVO examvo);

    /**
     * 新增数据
     *
     * @param elExam 实例对象
     * @return 影响行数
     */
    int insert(ElExam elExam);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExam> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ElExam> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExam> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<ElExam> entities);

    /**
     * 修改数据
     *
     * @param elExam 实例对象
     * @return 影响行数
     */
    int update(ElExam elExam);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    int deleteByIds(List<Long> ids);

    List<ElExam> queryMyExamList(ElExam exam);
}

